"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _util = require("../_util");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _setDefaultProps;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var _createNamespace = (0, _util.createNamespace)('picker-column'),
    bem = _createNamespace.bem;

var range = function range(num, min, max) {
  return Math.min(Math.max(num, min), max);
};

var PickerColumn = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var column = props.column,
      isCascadingMenu = props.isCascadingMenu,
      itemHeight = props.itemHeight,
      baseOffset = props.baseOffset,
      columnValue = props.columnValue,
      columnIndex = props.columnIndex,
      onChange = props.onChange,
      timeStamp = props.timeStamp;

  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      offset = _useState2[0],
      setOffset = _useState2[1]; // translate偏移量


  var _useState3 = (0, _react.useState)(0),
      _useState4 = _slicedToArray(_useState3, 2),
      startY = _useState4[0],
      setStartY = _useState4[1]; // 鼠标起始位置


  var _useState5 = (0, _react.useState)(0),
      _useState6 = _slicedToArray(_useState5, 2),
      startOffset = _useState6[0],
      setStartOffset = _useState6[1];

  var _useState7 = (0, _react.useState)(0),
      _useState8 = _slicedToArray(_useState7, 2),
      touchstartTime = _useState8[0],
      setTouchstartTime = _useState8[1];

  var _useState9 = (0, _react.useState)(0),
      _useState10 = _slicedToArray(_useState9, 2),
      duration = _useState10[0],
      setDuration = _useState10[1];

  var _useState11 = (0, _react.useState)(0),
      _useState12 = _slicedToArray(_useState11, 2),
      selectedIndex = _useState12[0],
      setSelectedIndex = _useState12[1];

  var defaultDuration = 200; // 默认transition时间
  // 1,columnValue存在时计算默认selectedIndex。2，级联菜单联动时selectedIndex = 0

  (0, _react.useEffect)(function () {
    var selectedIndex = 0;
    column.forEach(function (item, index) {
      if (item.value == columnValue || item.text === columnValue || item.title === columnValue) {
        selectedIndex = index;
      }
    });
    setSelectedIndex(selectedIndex);
    emitChange();
  }, [column, columnValue, timeStamp]); // selectedIndex change

  (0, _react.useEffect)(function () {
    emitChange();
    resetOffset(selectedIndex);
  }, [selectedIndex]);

  var emitChange = function emitChange() {
    var obj = column[selectedIndex];
    if (obj) onChange(columnIndex, selectedIndex, column);
  };

  var handleListTouchStart = function handleListTouchStart(e) {
    setDuration(0);
    setStartY(e.targetTouches[0].clientY);
    setTouchstartTime(new Date());
  };

  var handleListTouchMove = function handleListTouchMove(e) {
    var deltaY = e.targetTouches[0].clientY - startY;
    var offset = range(startOffset + deltaY, -(column.length * itemHeight), itemHeight);
    setOffset(offset);
  };

  var handleListTouchEnd = function handleListTouchEnd(e) {
    /**
       * 惯性滑动思路
       * 在手指离开屏幕时，如果和上一次 move 时的间隔小于 `MOMENTUM_LIMIT_TIME` 且 move距离大于 `MOMENTUM_LIMIT_DISTANCE` 时，执行惯性滑动
       */
    var duration = new Date() - touchstartTime;
    var distance = offset - startOffset;
    var MOMENTUM_LIMIT_TIME = 300;
    var MOMENTUM_LIMIT_DISTANCE = 15;
    var allowMomentum = duration < MOMENTUM_LIMIT_TIME && Math.abs(distance) > MOMENTUM_LIMIT_DISTANCE;
    var selectedIndex = allowMomentum ? momentum(distance, duration) : getIndexByOffset(offset);
    setDuration(defaultDuration);
    setSelectedIndex(selectedIndex);
    resetOffset(selectedIndex);
  };

  var resetOffset = function resetOffset(selectedIndex) {
    var _offset = -selectedIndex * itemHeight;

    setOffset(_offset);
    setStartOffset(_offset);
  };

  var momentum = function momentum(distance, duration) {
    var speed = Math.abs(distance / duration);
    distance = offset + speed / 0.003 * (distance < 0 ? -1 : 1);
    var selectedIndex = getIndexByOffset(distance);
    return selectedIndex;
  };

  var getIndexByOffset = function getIndexByOffset(offset) {
    return range(Math.round(-offset / itemHeight), 0, column.length - 1);
  };

  var toSetSelectedIndex = function toSetSelectedIndex(selectedIndex) {
    var offset = -selectedIndex * itemHeight;
    setOffset(offset);
    setStartOffset(offset);
    setSelectedIndex(selectedIndex);
    setDuration(defaultDuration);
  };

  var ulStyle = {
    transform: "translate3d(0, ".concat(offset + baseOffset, "px, 0)"),
    transitionDuration: "".concat(duration, "ms"),
    transitionProperty: duration ? 'all' : 'none'
  };
  console.log('pickerColumn mounted or update');
  return /*#__PURE__*/_react.default.createElement("ul", {
    className: bem({
      'flex-1': !isCascadingMenu
    }),
    style: ulStyle,
    onTouchStart: handleListTouchStart,
    onTouchMove: handleListTouchMove,
    onTouchEnd: handleListTouchEnd
  }, column.map(function (item, index) {
    var text = item.text || item.title;
    return /*#__PURE__*/_react.default.createElement("li", {
      key: text
    }, text);
  }));
});
(0, _util.setDefaultProps)(PickerColumn, (_setDefaultProps = {
  column: {
    type: _propTypes.default.array
  },
  columnIndex: {
    type: _propTypes.default.number
  },
  columnValue: {
    type: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string])
  },
  itemHeight: {
    type: _propTypes.default.number
  },
  baseOffset: {
    type: _propTypes.default.number
  },
  isCascadingMenu: {
    type: _propTypes.default.bool
  }
}, _defineProperty(_setDefaultProps, "itemHeight", {
  type: _propTypes.default.number
}), _defineProperty(_setDefaultProps, "onChange", {
  type: _propTypes.default.func,
  default: function _default(selectedVal, selectedIndex, columnIndex) {}
}), _setDefaultProps));

var _default2 = /*#__PURE__*/(0, _react.memo)(PickerColumn);

exports.default = _default2;